#ifndef __I_CONFIG_H__
#define __I_CONFIG_H__

// Dummy to get type 'bool'
#include <string>



struct ConfigEntryTag;



class I_CONFIG
{
  public:
    I_CONFIG ();
    I_CONFIG (const char *CfgName);
    ~I_CONFIG ();

    void ReadConfig (const char *CfgName);
    char *GetConfigString (char *Section, char *Key, char *Default);
    int  GetConfigInt (char *Section, char *Key, int Default);
    bool GetConfigBool (char *Section, char *Key, bool Default);
    char *GetFirstEntry (char *Section, char **pKey);
    char *GetNextEntry (char **pKey);
    int  GetLineNbr ();
    void DiscardConfig ();

  private:
    void initVars ();
    char *my_strdup (char *s);
    void AddConfigEntry (char *Section, char *Key, char *Value, int Line);
    char *StripSpace (char *s);
    char *StripQuotes (char *s);

    struct ConfigEntryTag *CfgList;
    struct ConfigEntryTag *CfgLast;
    struct ConfigEntryTag *TmpEntry;

    char *TmpSection;
    char *CurSection;
};


#endif
