#include "TAdditionalArea.h"
#include <ctype.h>
#include "TMaxSeverity.h"



TAdditionalArea::TAdditionalArea (const char *name, const char *fpath, const char *fbbs, const char *desc, int sev)
: fAreaName (name), fAreaPath (fpath), fAreaFbbs (fbbs), fAreaDesc (desc), fAreaSeverity (sev)
{
  for (int i = 0; i < fAreaName.length (); i++)
    fAreaName[i] = toupper (fAreaName[i]);
}



TAdditionalArea::TAdditionalArea (const char *name, const char *attribs)
: fAreaName (name)
{
  char *pPath;
  char *pFbbs;
  char *pSev;
  char *pDesc;

  pPath = new char[strlen (attribs) + 1];
  strcpy (pPath, attribs);
  pSev = 0;
  pDesc = 0;
  if ((pFbbs = strchr (pPath, ',')) != 0)
  {
    *pFbbs = '\0';
    for (pFbbs++; (*pFbbs != '\0') && (*pFbbs == ' '); pFbbs++);

    if ((pSev = strchr (pFbbs, ',')) != 0)
    {
      *pSev = '\0';
      for (pSev++; (*pSev != '\0') && (*pSev == ' '); pSev++);

      if ((pDesc = strchr (pSev, ',')) != 0)
      {
        *pDesc = '\0';
        for (pDesc++; (*pDesc != '\0') && (*pDesc == ' '); pDesc++);

        purgeTrailSpaces (pDesc);
      }
      purgeTrailSpaces (pSev);
    }
    purgeTrailSpaces (pFbbs);
  }
  purgeTrailSpaces (pPath);

  fAreaPath = pPath;
  if ((*pPath != '\0') && (*(strrev (pPath)) != '\\'))
    fAreaPath += "\\";

  if ((*pPath != '\0') && (strlen (pFbbs) == 0))
    fAreaFbbs = fAreaPath + "FILES.BBS";
  else
    fAreaFbbs = pFbbs;

  fAreaDesc = pDesc;

  fAreaSeverity = TMaxSeverity::ascii2severity (pSev);

  delete [] pPath;
}



TAdditionalArea::TAdditionalArea (const TAdditionalArea & clone)
: fAreaName (clone.fAreaName), fAreaPath (clone.fAreaPath), fAreaFbbs (clone.fAreaFbbs),
  fAreaDesc (clone.fAreaDesc), fAreaSeverity (clone.fAreaSeverity)
{
}



void TAdditionalArea::purgeTrailSpaces (char *buffer)
{
  char *ptr;
  int  purge;

  for (purge = strlen (buffer), ptr = &buffer[purge]; (purge >= 0) && (*ptr == ' '); purge--, ptr--)
    *ptr = '\0';
}

