#ifndef __ADDITIONALAREA_H__
#define __ADDITIONALAREA_H__


#include <string>
#include <list>


class TAdditionalArea
{
  public:
    TAdditionalArea () : fAreaSeverity (1) { }
    TAdditionalArea (const char *name) : fAreaName (name), fAreaSeverity (1) { }
    TAdditionalArea (const char *name, const char *fpath, const char *fbbs, const char *desc, int sev);
    TAdditionalArea (const char *name, const char *attribs);
    TAdditionalArea (const TAdditionalArea & clone);

    bool operator == (const TAdditionalArea & right) const { return fAreaName == right.fAreaName; }
    bool operator < (const TAdditionalArea & right) const { return fAreaName < right.fAreaName; }

    const string & getAreaName () const { return fAreaName; }
    const string & getFilePath () const { return fAreaPath; }
    const string & getFilesBbs () const { return fAreaFbbs; }
    const string & getFileDesc () const { return fAreaDesc; }
    int getSeverity () const { return fAreaSeverity; }

  private:
    void purgeTrailSpaces (char *buffer);

    string fAreaName;
    string fAreaPath;
    string fAreaFbbs;
    string fAreaDesc;
    int    fAreaSeverity;
};



typedef list<TAdditionalArea> TAdditionalAreaList;



#endif

