#ifndef __TAREAINFO_H__
#define __TAREAINFO_H__

//#include <stdio.h>
#include <iostream>
#include <string>
#include <vector>
#include "TArea.h"
#include "TFormattedOutput.h"



class TAreaInfo
{
  private:
    struct AreaInfoValue
    {
      AreaInfoValue (const TArea & area, long count, unsigned long size);

      int fRefCount;

      string fArea;
      string fDesc;
      long   fCount;
      unsigned long fSize;
    };

  public:
    TAreaInfo () : fAreaInfo (0) {}
    TAreaInfo (const TArea & area, long count, unsigned long size);
    TAreaInfo (const TAreaInfo & clone);
    ~TAreaInfo ();

    TAreaInfo & operator = (const TAreaInfo & right);

    bool operator == (const TAreaInfo & right) const { return fAreaInfo->fArea == right.fAreaInfo->fArea; }
    bool operator < (const TAreaInfo & right) const { return fAreaInfo->fArea < right.fAreaInfo->fArea; }

    void write (ostream & f, TFormattedOutput & format, int inKBytes);

    const string & name () const { return fAreaInfo->fArea; }
    const string & desc () const { return fAreaInfo->fDesc; }
    long count () const { return fAreaInfo->fCount; };
    unsigned long size () const { return fAreaInfo->fSize; };

  private:
    AreaInfoValue *fAreaInfo;
};



class TAreaInfoList : public vector<TAreaInfo>
{
  public:
    TAreaInfoList (TFormattedOutput & format);

    void add (const TAreaInfo & areainfo);
    void write (ostream & f, int inKBytes);
    long getCount () { return fCount; };
    unsigned long getSize () { return fSize; };

  private:
    long fCount;
    unsigned long fSize;
    unsigned long fMinor;
    TFormattedOutput & fFormat;
};



#endif

