#ifndef __TAREALIST_H__
#define __TAREALIST_H__

#include <list>
#include <map>
#include "TArea.h"
#include "TAreaSort.h"
#include "TAreaSelection.h"
#include "TAdditionalArea.h"



// forward reference
class TAreaConfig;
class TAreaListEntry;



class TAreaList : public list<TAreaListEntry *>
{
  public:
    TAreaList (const string & path, bool mustSort, const TAreaSelectionList & fcmp,
               const TAdditionalAreaList & addAreas, const TAreaSort & sort);
    ~TAreaList ();

    void locateFirstArea ();
    bool getArea (struct TArea & inf, const TAdditionalAreaList & addAreas);

    string divisionDescription (const string & area) const;

  private:
    typedef map<string, string, less<string> > descMap;

    TAreaConfig         *fAreaConfig;
    int                 fVersion;
    iterator            fIterator;
    descMap             fDescMap;
};



#endif

