#ifndef __TAREALISTENTRY_H__
#define __TAREALISTENTRY_H__

#include <string>
#include "TAreaSort.h"



class TAreaListEntry
{
  public:
    TAreaListEntry () : fOffset (-1), fHandled (false) {}
    TAreaListEntry (const string & name) : fOffset (-1), fHandled (false) {}
    TAreaListEntry (const string & name, long ofs, const TAreaSort & sort);
    TAreaListEntry (const TAreaListEntry & clone);

    bool operator == (const TAreaListEntry & right) const { return fName == right.fName; }
    bool operator < (const TAreaListEntry & right) const { return fName < right.fName; }
    bool operator > (const TAreaListEntry & right) const { return fName > right.fName; }

    TAreaListEntry & operator = (const TAreaListEntry & right);

    const string & name () const { return fName; }
    long offset () const { return fOffset; }
    const TAreaSort & sortInfo () const { return fSortInfo; }

    void setHandled () { fHandled = true; }
    bool isHandled () const { return fHandled; }

  private:
    string    fName;
    long      fOffset;
    TAreaSort fSortInfo;
    bool      fHandled;
};



#endif

