#ifndef __AREASELECTION_H__
#define __AREASELECTION_H__

#include <string>
#include <list>
#include "TAreaSort.h"



class TAreaSelection
{
  public:
    TAreaSelection () : fExcluded (false) {}
    TAreaSelection (const string & pattern, bool excluded, const TAreaSort & sort);

    bool operator == (const TAreaSelection & right) { return fPattern == right.fPattern; }
    bool operator < (const TAreaSelection & right) { return fPattern < right.fPattern; }

    const TAreaSort & sortInfo () const { return fSort; }
    bool excluded () const { return fExcluded; }

    bool match (const string & str) const;

  private:
    string    fPattern;
    TAreaSort fSort;
    bool      fExcluded;
};



class TAreaSelectionList : public list<TAreaSelection>
{
  public:
    TAreaSelectionList () {}

    void addEntry (const string & key, const TAreaSort & sort);

    bool matchArea (const string & area, TAreaSort & sort) const;
};



#endif

