#ifndef __AREASORT_H__
#define __AREASORT_H__



class TAreaSort
{
  public:
    enum SortKey
    {
      NoSorting,
      SortByFile,
      SortByDate
    };

    enum SortDirection
    {
      SortAscending,
      SortDescending
    };

    TAreaSort (SortKey key = NoSorting, SortDirection order = SortAscending)
    : fSortKey (key), fSortOrder (order) {}
    TAreaSort (const TAreaSort & copy)
    : fSortKey (copy.fSortKey), fSortOrder (copy.fSortOrder) {}

    TAreaSort & operator = (const TAreaSort & right);

    SortKey getSortKey () const { return fSortKey; }
    SortDirection getSortOrder () const { return fSortOrder; }

  private:
    SortKey       fSortKey;
    SortDirection fSortOrder;
};



#endif

