#ifndef __TFILEENTRY_H__
#define __TFILEENTRY_H__

#include <time.h>
#include <string>
#include "TAreaSort.h"



class TFileEntry
{
  public:
    TFileEntry ();
    TFileEntry (const string & path, const string & name,
                const string & desc, const TAreaSort & sort);
    TFileEntry (const TFileEntry & clone);

    bool operator == (const TFileEntry & right) const;
    bool operator < (const TFileEntry & right) const;
    bool operator > (const TFileEntry & right) const;

    TFileEntry & operator = (const TFileEntry & right);

    const string & name () const { return fName; }
    const string & desc () const { return fDesc; }
    int  day () const { return fDay; };
    int  month () const { return fMonth; };
    int  year () const { return fYear; };
    time_t fileTime () const { return fFileTime; }
    long size () const { return fSize; };

    bool available () const { return (fSize != 0) || (fFileTime != 0); }

    void purgeSize ();
    void appendDesc (const string & desc);

  private:
    void getFileSizeDate (const string & path);

    string    fName;
    string    fDesc;
    long      fSize;
    int       fDay;
    int       fMonth;
    int       fYear;
    time_t    fFileTime;
    TAreaSort fSort;
};



#endif

