#ifndef __FILELIST_H__
#define __FILELIST_H__


#include <list>
#include "TAreaSort.h"
#include "TFileEntry.h"



class TFileList : public list<TFileEntry>
{
  public:
    TFileList (const string & path, const string & fbbs, int skipLines,
               bool killsize, time_t runtime, time_t agenew,
               const TAreaSort & sort, char tagChar, int bbsIndent);

    long getSize () const { return fSumSize; };
    int  getCount () const { return fSumFiles; };
    long getNewSize () const { return fNewSize; };
    int  getNewCount () const { return fNewFiles; };
    const TFileEntry * getNewestFile () const { return fSumFiles > 0 ? &fLatestFile : 0; }

  private:
    bool handleFBbsEntry (TFileEntry & entry, const string & path, const string & line);

    bool fKillSize;
    long fSumSize;
    int  fSumFiles;
    long fNewSize;
    int  fNewFiles;
    time_t fRunTime;
    time_t fAgeNew;
    TAreaSort fSort;
    TFileEntry fLatestFile;
};


#endif


