#ifndef __TFORMATTEDOUTPUT_H__
#define __TFORMATTEDOUTPUT_H__

//#include <stdio.h>
#include <iostream>
#include <vector>
#include <map>
#include <string>

// forward references
class ParamEntry;



class TFormattedOutput
{
  public:
    enum Keys
    {
      ENTRY_NAME = 0,
      ENTRY_DESC,
      ENTRY_SIZE,
      ENTRY_DATE,
      ENTRY_COUNT,
      SECTION_NAME,
      SECTION_DESC,
      SECTION_SIZE,
      SECTION_COUNT,
      SECTION_ACCESS,
      SECTION_LATEST,
      BBS_NAME,
      CREATION_DATE,
      COPYRIGHT,
      ENTRY_NEWMARKER,
      VERSATILE
    };

    TFormattedOutput ();
    ~TFormattedOutput ();

    void insert (char key, const string & string);

    void setParam (Keys key, const char *value);
    void setParam (Keys key, const string & value);
    void setParam (Keys key, unsigned long value, bool inK = false);

    void writeTop (ostream & f);
    void writeLine (ostream & f, bool optional = false);
    void writeTail (ostream & f);

    bool empty () { return fEmpty; }

  private:
    typedef vector<string> stringVector;
    typedef map<char, ParamEntry *, greater<char> > paramList;

    void addtolist (stringVector & list, const string & item);
//    void writeSection (FILE *f, stringVector & list);
//    void writeRow (FILE *f, const string & line);
    void writeSection (ostream & f, stringVector & list);
    void writeRow (ostream & f, const string & line);
    ParamEntry *getParm (char key);
//    void printParm (FILE *f, char key, int width, int align);
    void printParm (ostream & f, char key, int width, int align);

    bool           fEmpty;
    stringVector   fHeader;
    stringVector   fList;
    stringVector   fOptional;
    stringVector   fTrailer;
    paramList      fParams;
};



#endif

