#include "THtmlAreaWriter.h"



THtmlAreaWriter::THtmlAreaWriter (const string & path, const string & division,
                                  const string & desc, TFormattedOutput & format)
: fOut (path.c_str ()), fDivision (division), fFormat (&format)
{
  fFormat->setParam (TFormattedOutput::SECTION_NAME, division.c_str ());
  fFormat->setParam (TFormattedOutput::SECTION_DESC, desc.c_str ());
}



THtmlAreaWriter::~THtmlAreaWriter ()
{
  if (fOut.good ())
    fFormat->writeTail (fOut);
}



bool THtmlAreaWriter::open (unsigned long count, unsigned long size)
{
  if (fOut.good ())
  {
    fFormat->setParam (TFormattedOutput::SECTION_SIZE, size, true);
    fFormat->setParam (TFormattedOutput::SECTION_COUNT, count);

    fFormat->writeTop (fOut);
  }

  return fOut.good ();
}



void THtmlAreaWriter::writeEntry (const string & name, const string & link,
                                  const string & desc, unsigned long count, unsigned long size)
{
  if (fOut.good ())
  {
    fFormat->setParam (TFormattedOutput::ENTRY_NAME, name.c_str ());
    fFormat->setParam (TFormattedOutput::VERSATILE, link.c_str ());
    fFormat->setParam (TFormattedOutput::ENTRY_DESC, desc.c_str ());
    fFormat->setParam (TFormattedOutput::ENTRY_COUNT, count);
    fFormat->setParam (TFormattedOutput::ENTRY_SIZE, size, true);

    fFormat->writeLine (fOut, link.length () == 0);
  }
}

