#ifndef __THTMLDIRMAPPER_H__
#define __THTMLDIRMAPPER_H__

#include <string>
#include <list>



class THtmlDirMapperEntry
{
  public:
    THtmlDirMapperEntry () {}
    THtmlDirMapperEntry (const string & original, const string & replace);
    THtmlDirMapperEntry (const THtmlDirMapperEntry & clone);

    THtmlDirMapperEntry & operator = (const THtmlDirMapperEntry & right);
    bool operator == (const THtmlDirMapperEntry & right) const;
    bool operator < (const THtmlDirMapperEntry & right) const;

    bool match (const string & path) const;

    const string & original () const { return fOriginal; }
    const string & replacement () const { return fReplace; }

  private:
    string fOriginal;
    string fReplace;
};



class THtmlDirMapper
{
  public:
    THtmlDirMapper () {}

    void addMapping (const string & original, const string & replace);

    bool mapPath (const string & path, string & newPath) const;

  private:
    typedef list<THtmlDirMapperEntry> mapperList;

    mapperList fMapperList;
};



#endif

