#ifndef __TWRITEAREA_H__
#define __TWRITEAREA_H__


//#include <stdio.h>
#include <iostream>
#include <time.h>
#include <string>
#include "TFileList.h"

// forward references - will be resolved in *.cpp file
class TArea;
class TFileEntry;
class TFormattedOutput;
class TFileWriter;



class TWriteArea
{
  public:
    enum Style
    {
      STYLE_TEXT,
      STYLE_HTML
    };

    TWriteArea (ostream & fall, ostream *fnew, const string & fileMark,
                bool inKBytes, int wordBreak, Style style,
                time_t runTime, time_t recentNew, TFormattedOutput & format);
    ~TWriteArea ();

    void writeArea (const TArea & area, const TFileList & fileList);

    ostream *allfilesFile () { return fAllfilesFile; }
    ostream *newfilesFile () { return fNewfilesFile; }

  private:
    void writeHeader (ostream & f, const TArea & area,
                      long count, unsigned long size, const TFileEntry *latest);
    void writeFooter (ostream & f, const TArea & area,
                      long count, unsigned long size, const TFileEntry *latest);

    ostream   *fAllfilesFile;
    ostream   *fNewfilesFile;
    bool      fInKBytes;
    time_t    fRuntime;
    time_t    fRecentNew;
    TFormattedOutput *fFormat;
    TFileWriter *fAllFileWriter;
    TFileWriter *fNewFileWriter;
};


#endif
